/*
*/
#ifndef __RTL_H__
#define __RTL_H__
#include <stdio.h>
#include <pthread.h>
#include <limits.h>
#include <time.h>
#include <mqueue.h>
#include <signal.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sched.h>
#include <string.h>
#include <sys/mman.h>
#include <cpuset.h>
#include <sched.h>
#include <mpadvise.h>
#include <termios.h>
#include <stdlib.h>



#define __EMULATE_RTLINUX__
#define hrtime_t long long

/* Section 2  */
#define rtl_close	close
#define rtl_ftruncate	rtl_ftruncate
#define rtl_gpos_unlink	unlink
#define rtl_inb		inb
#define rtl_inb_p	inb_p
#define rtl_inl		inl
#define rtl_inl_p	inl_p
#define rtl_inw		inw
#define rtl_inw_p	inw_p
#define rtl_ioctl	ioctl
#define rtl_lseek	lseek
#define rtl_mmap	mmap
#define rtl_munmap	unmap
#define rtl_open	open
#define rtl_outb	outb
#define rtl_outb_p	outb_p
#define rtl_outl	outl
#define rtl_outl_p	outl_p
#define rtl_outw	outw
#define rtl_outw_p	outw_p
#define rtl_read	read
#define rtl_shm_open	shm_open
#define rtl_shm_unlink	shm_unlink 
#define rtl_unlink	unlink
#define rtl_write 	write



/* Section 3 */

    /* malloc */
#define	rtl_size_t 	size_t 
#define rtl_rt_malloc	malloc
#define rtl_rt_free	free
#define rtl_rt_realloc	realloc
    /* calloc */
#define	rtl_rt_calloc	calloc
//void *rtl_rt_malloc_pool(int pool, rtl_size_t size);
//void *rtl_rt_calloc_pool(int pool, rtl_size_t nmemb, rtl_size_t size);
//int rtl_init_mem_pool(int pool, int type, int chunksize, int numchunks);
//void rtl_cleanup_mem_pool(int pool);
    /* debugpr */
#define	debugpr	printf
    /* onewayq */ // not support

int rtf_create(unsigned int fifo,int size);
long rtf_create_handler(unsigned long fifo,long (*handler)(unsigned long fifo) );
#define rtf_create_rt_handler	rtf_create_handler
int rtf_destroy(unsigned int fifo);
int rtf_flush(unsigned int fifo);
int rtf_get(unsigned int fifo,char *buff,int count);
    // rtf_isempty
    // rtf_isused
    // rtf_link_user_ioctl
    // rtf_make_user_pair
int rtf_put(unsigned int fifo,char *buff,int count);
    // rtf_resize
    // rtl_a_clear
    // rtl_a_decr
    // rtl_a_incr
    // rtl_allow_interrupts
    // rtl_a_set
    // rtl_breakpoint
    // rtl_cleanup_mem_pool
hrtime_t clock_gethrtime(clockid_t clock);
#define RTL_CLOCK_REALTIME CLOCK_REALTIME
#define rtl_timespec timespec
#define rtl_clockid_t	clockid_t
#define rtl_clock_getres	clock_getres
#define rtl_clock_gettime	clock_gettime
#define rtl_clock_nanosleep	clock_nanosleep
#define rtl_clock_settime	clock_settime
int rtl_cpu_exists (int cpu);
    // rtl_decr_dev_usage
    // rtl_free_irq
    // rtl_free_soft_irq
    // rtl_freq_cur
    // rtl_freq_list
    // rtl_freq_set
    // rtl_getcpuid
    // rtl_get_soft_irq
    // rtl_global_pend_irq
    // rtl_gpos_free
    // rtl_gpos_malloc
    // rtl_gpos_register_dev
    // rtl_gpos_unregister_dev
    // rtl_hard_disable_irq
    // rtl_hard_enable_irq
    // rtl_incr_dev_usage
    // rtl_init_mem_pool
    // rtl_irq_set_affinity
#define	rtl_longjmp	longjmp
#define rtl_jmp_buf 	jmp_buf
#define	rtl_main_wait	pause
#define	rtl_mkfifo	mkfifo
#define	rtl_mode_t	mode_t
    // rtl_namei
#define rtl_nanosleep	nanosleep
    // rtl_no_interrupts
int rtl_num_cpus(void);
#define rtl_perror	perror
#define rtl_printf 	printf
#define rtl_pthread_t rtl_pthread
#define rtl_pthread_attr_destroy		pthread_attr_destroy
#define rtl_pthread_attr_t 			pthread_attr_t
    // rtl_pthread_attr_getcpu_np
#define rtl_pthread_attr_getdetachstate		pthread_attr_getdetachstate
    // rtl_pthread_attr_getfp_np
    // rtl_pthread_attr_getreserve_np
#define rtl_pthread_attr_getschedparam		pthread_attr_getschedparam 
#define rtl_pthread_attr_getstackaddr		pthread_attr_getstackaddr
#define rtl_pthread_attr_getstacksize		pthread_attr_getstacksize
#define rtl_pthread_attr_init			pthread_attr_init
    // rtl_pthread_attr_setcpu_np
#define rtl_pthread_attr_setdetachstate		pthread_attr_setdetachstate
    // rtl_pthread_attr_setfp_np
    // rtl_pthread_attr_setreserve_np
#define rtl_pthread_attr_setschedparam		pthread_attr_setschedparam
#define rtl_pthread_attr_setstackaddr		pthread_attr_setstackaddr
#define rtl_pthread_attr_setstacksize		pthread_attr_setstacksize
#define rtl_pthread_cancel			pthread_cancel
#define rtl_pthread_cleanup_pop			pthread_cleanup_pop
#define rtl_pthread_cleanup_push		pthread_cleanup_push
#define rtl_pthread_condattr_t			pthread_condattr_t
#define rtl_pthread_condattr_destroy		pthread_condattr_destroy
#define rtl_pthread_condattr_getpshared		pthread_condattr_getpshared
#define rtl_pthread_condattr_init		pthread_condattr_init
#define rtl_pthread_condattr_setpshared		pthread_condattr_setpshared
#define rtl_pthread_cond_broadcast		pthread_cond_broadcast
#define rtl_pthread_cond_destroy		pthread_cond_destroy
#define rtl_pthread_cond_init			pthread_cond_init
#define rtl_pthread_cond_signal			pthread_cond_signal
#define rtl_pthread_cond_timedwait		pthread_cond_timedwait
#define rtl_pthread_cond_wait			pthread_cond_wait 
int rtl_pthread_create(pthread_t *thread, pthread_attr_t *attr, void *(*start_routine)(void *), void *arg);
    // rtl_pthread_delete_np
#define rtl_pthread_detach			pthread_detach
#define rtl_pthread_equal			pthread_equal
#define rtl_pthread_exit			pthread_exit
#define rtl_pthread_getcpuclockid		pthread_getcpuclockid
#define rtl_pthread_getschedparam		pthread_getschedparam
#define rtl_pthread_getspecific			pthread_getspecific
#define rtl_pthread_idle			pause
#define rtl_pthread_join			pthread_join
#define rtl_pthread_key_create			pthread_key_delete
#define rtl_pthread_key_delete			pthread_key_delete
#define rtl_pthread_kill			pthread_kill
#define rtl_pthread_linux			pause
#define rtl_pthread_mutex_t			pthread_mutex_t
#define rtl_pthread_make_periodic_np		pthread_make_periodic_np
#define rtl_pthread_mutexattr_destroy		pthread_mutexattr_destroy
#define rtl_pthread_mutexattr_getprioceiling	pthread_mutexattr_getprioceiling
#define rtl_pthread_mutexattr_getprotocol	pthread_mutexattr_getprotocol
#define rtl_pthread_mutexattr_getpshared	pthread_mutexattr_getpshared
#define rtl_pthread_mutexattr_gettype		pthread_mutexattr_gettype
#define rtl_pthread_mutexattr_init		pthread_mutexattr_init
#define rtl_pthread_mutexattr_setprioceiling	pthread_mutexattr_setprioceiling
#define rtl_pthread_mutexattr_setprotocol	pthread_mutexattr_setprotocol
#define rtl_pthread_mutexattr_setpshared	pthread_mutexattr_setpshared
#define rtl_pthread_mutexattr_settype		pthread_mutexattr_settype
#define rtl_pthread_mutex_destroy		pthread_mutex_destroy
#define rtl_pthread_mutex_getprioceiling	pthread_mutex_getprioceiling
#define rtl_pthread_mutex_init			pthread_mutex_init
#define rtl_pthread_mutex_lock			pthread_mutex_lock
#define rtl_pthread_mutex_setprioceiling	pthread_mutex_setprioceiling
#define rtl_pthread_mutex_timedlock		pthread_mutex_timedlock
#define rtl_pthread_mutex_trylock		pthread_mutex_trylock
#define rtl_pthread_mutex_unlock		pthread_mutex_unlock
#define rtl_pthread_self			pthread_self
#define rtl_pthread_setcancelstate		pthread_setcancelstate
#define rtl_pthread_setcanceltype		pthread_setcanceltype
	// rtl_pthread_setfp_np
#define rtl_pthread_setschedparam		pthread_setschedparam
#define rtl_pthread_setspecific			pthread_setspecific
#define rtl_pthread_spin_destroy		pthread_spin_destroy
#define rtl_pthread_spin_init			pthread_spin_init
#define rtl_pthread_spin_lock			pthread_spin_lock
#define rtl_pthread_spin_trylock		pthread_spin_trylock
#define rtl_pthread_spin_unlock			pthread_spin_unlock
int pthread_suspend_np(pthread_t thread);
#define rtl_pthread_testcancel			pthread_testcancel
int pthread_wait_np(void);
int pthread_wakeup_np(pthread_t thread);
    //rtl_put_circle
    //rtl_put_fillcircle
    //rtl_put_fillrect
    //rtl_put_line
    //rtl_put_pixel
    //rtl_put_rect
    //rtl_put_text
    //rtl_register_dev
    //rtl_register_rtldev
    //rtl_request_irq
    //rtl_restore_interrupts
    //rtl_rt_calloc
    //rtl_rt_calloc_pool
    //rtl_rt_free
    //rtl_rt_malloc
    //rtl_rt_malloc_pool
    //rtl_rt_realloc
#define rtl_sched_get_priority_max		get_priority_max 
#define rtl_sched_get_priority_min		get_priority_min
#define rtl_sched_yield				sched_yield
#define rtl_sem_t				sem_t
#define rtl_sem_close				sem_close
#define rtl_sem_destroy				sem_destroy
#define rtl_sem_getvalue			sem_getvalue
#define rtl_sem_init				sem_init
#define rtl_sem_open				sem_open
#define rtl_sem_post				sem_post
#define rtl_sem_timedwait			sem_timedwait
#define rtl_sem_trywait				sem_trywait
#define rtl_sem_unlink				sem_unlink
#define rtl_sem_wait				sem_wait
#define	rtl_jmp_buf				jmp_buf
#define rtl_setjmp				setjmp
#define rtl_sigaction				sigaction
	// rtl_stop_interrupts
    // rtl_test_bit_and_clear
    // rtl_test_bit_and_set
#define rtl_timespec				timespec
    // rtl_timespec_add
    // rtl_timespec_add_ns
    // rtl_timespec_eq
    // rtl_timespec_from_ns
    // rtl_timespec_ge
    // rtl_timespec_gt
    // rtl_timespec_le
    // rtl_timespec_lt
    // rtl_timespec_normalize
    // rtl_timespec_nz
    // rtl_timespec_sub
    // rtl_timespec_to_ns
#define rtl_uname				uname
    // rtl_unregister_dev
    // rtl_unregister_rtldev
#define rtl_usleep				usleep
    // sched_get_cpufreq_max
    // sched_get_cpufreq_min 


#define WAITSIGNAL	(SIGRTMIN+2)

typedef struct
{
	timer_t		timer_key;
	int		timer_sno;
	int		state;
	int		request;
	int		tno;
	pthread_t	pid;
} rtltsd_t;

typedef struct
{
	int flag;
	char    f_name[256];
	long (*handler)(unsigned long fifo);
	pthread_attr_t   attributes;
#ifdef MESSAGE_QUEUE
        mqd_t f_id;
        struct mq_attr f_attr;
	struct sigevent notification;
#else
        int f_id;
	pthread_t	pid;
	//struct timespec timeout;
	struct timeval  timeout;
	sigset_t sigmask;
	fd_set readfds; 
#endif
} rtl_fifo_t;

#define RTL_SUSPEND	(0)
#define RTL_RUN		(1)

hrtime_t gethrtime(void);
void init_valueue(void);
int pthread_make_periodic_np(pthread_t thread,hrtime_t start_time,hrtime_t period);
int pthread_suspend_np(pthread_t thread);
int pthread_wait_np(void);
int pthread_wakeup_np(pthread_t thread);
int pthread_attr_setcpu_np(const pthread_attr_t *attr,int cpu);
int pthread_attr_getcpu_np(const pthread_attr_t *attr,int *cpu);

#endif /* __RTL_H__ */
