/*
*/

#include <stdio.h>
#include <stdlib.h>
#define __USE_GNU

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <aio.h>
#include <sys/mman.h>
#include <malloc.h>




#define DATA_BUF_SIZE 4096
#define DATA_BUF_NUM 128

aio_test(int fd)
{
	int n,status;
	unsigned char *  Aio_buff[DATA_BUF_NUM];
	struct aiocb Aiocb[DATA_BUF_NUM];
	struct aiocb *List[DATA_BUF_NUM];
	struct timespec timeout = {10,0};
        struct sigevent sig;

        for(n=0;n<DATA_BUF_NUM;n++)
        {
                Aio_buff[n] = (unsigned char*)memalign(sysconf(_SC_PAGESIZE),DATA_BUF_SIZE);
                	memset((void *)(Aio_buff[n]),n,DATA_BUF_SIZE);


                Aiocb[n].aio_buf = Aio_buff[n];
		Aiocb[n].aio_offset = (long long)(DATA_BUF_SIZE * n);
                Aiocb[n].aio_nbytes      = (long long)DATA_BUF_SIZE;
		Aiocb[n].aio_fildes	= fd;
                Aiocb[n].aio_reqprio     = 0;
                Aiocb[n].aio_lio_opcode  = LIO_WRITE;
                Aiocb[n].aio_sigevent.sigev_notify = SIGEV_NONE;
		List[n] = &Aiocb[n];
	
	}
	mlockall(MCL_CURRENT|MCL_FUTURE);

	lio_listio(LIO_WAIT,(struct aiocb **)&List[0],DATA_BUF_NUM, &sig);
	aio_suspend((const struct aiocb **)&List[0],DATA_BUF_NUM, &timeout);
	munlockall();

        for(n=0;n<DATA_BUF_NUM;n++)
	{
		status = aio_return(&(Aiocb[n]));
		if (status!=DATA_BUF_SIZE) printf("%d is write error\n",n);
	}
        for(n=0;n<DATA_BUF_NUM;n++)
	{
		status = aio_error(&(Aiocb[n]));
		if (status) printf("%d is error %d:%s\n",n,status,strerror(status));
	}

}

main()
{
	int fd;
	long long bytes;
	int dummy=0;

	bytes = DATA_BUF_SIZE * DATA_BUF_NUM ;

	if ((fd = open("realtime_file",(O_CREAT|O_DIRECT|O_WRONLY|O_SYNC|O_DSYNC|O_RSYNC), 0666)) <0)
	{
		exit(1);
	}

	printf("allocate %lld bytes\n",bytes);

	if (posix_fadvise(fd,0,bytes,POSIX_FADV_NOREUSE)<0)
	{
		fprintf(stderr,"fadvise error\n");
		exit(0);
	} else {
		if (posix_fallocate(fd,0,bytes)<0)
		{
			fprintf(stderr, "falocate error\n");
			exit(0);
		}
		bytes -= (long long)sizeof(int);
		lseek(fd,bytes,SEEK_SET);
		write(fd,&dummy,4);
		lseek(fd,0,SEEK_SET);
	}
	aio_test(fd);
	close(fd);



}




