#include <stdio.h>
#include <stdlib.h>
#define __USE_GNU
#include <string.h>
#include <unistd.h>
#include <sched.h>
#include <time.h>
#include <sys/times.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/vfs.h> 
#include <malloc.h>



#define	EXT2_OLD_SUPER_MAGIC	0xEF51
#define	EXT2_SUPER_MAGIC	0xEF53
#define	XFS_SUPER_MAGIC       0x58465342
#define	MSDOS_SUPER_MAGIC     0x4d44
#define	EFS_SUPER_MAGIC       0x00414A53
#define	SMB_SUPER_MAGIC       0x517B




#define MEG (1024.0*1024.0)
#define MB (1024*1024)
#define MAX_BUFFER	(1024*MB)
#define BLOCK_SIZE 512			/* min block size used */
#define	MAXBLOCKS (MAX_BUFFER/(BLOCK_SIZE))		/* 2048 = 1Mb at BLOCK_SIZE = 512 */

#define min(A,B) ((A) < (B) ? (A) : (B))
#define max(A,B) ((A) > (B) ? (A) : (B))

#if !defined(P_MYID)
#define P_MYID	0
#endif


int	max_file_size = 64*MB;
int 	maxtrans = 64*MB;
void	*dbuf;
int	fatal_errfunc(),errfunc(),inintr;
double	elapsed_time;
float	elapsed_u_cpu;
float	elapsed_s_cpu;
float	bps;
float	acs;
float	pucpu;
float	pscpu;
int	numtimes = 1000;
int	maxblocks;
int	buffer_size = 1; 
int	buf_size;
int	last_buffer_size;
int	samples_per_buf;
int	total_samples;
char 	*file_name = "DISK_TEST";
int	file_fd;
int	okcnt;
int	bufcnt;
int	err_occured;
int	fatal_err_occured;
int	f_err_cnt;
int	atty;
int	no_read;
int	no_write;
int	no_seq;
int	file_advise = POSIX_FADV_NORMAL;
char advise[256];
int xfs=0;
int direct=0;
int prealloc=0;
extern	int errno;



main(int argc, char **argv)
{
	char *argp;
	int tmp_cnt,status;
	struct statfs	statfsbuff;
	int random = 0;

	atty = isatty(1);
	strcpy(advise,"POSIX_FADV_NORMAL");

	while(--argc)
	{
		argv++;
		if(*(argp = *argv) != '-'){
			file_name = *argv;
			continue;
		}
		switch(*(++argp)){
		case 'h':
		case 'H':
		printf(" usage: -t nnn = iterations [1000] \n");
	        printf("        -nr = no reads \n");
		printf("        -nw = no writes \n");
		printf("        -ns = no sequential \n");
		printf("        -b nnn = initial block size [1]\n");
		printf("        -f name = filename [DISK_TEST] \n");
                printf("        -s nnn = size of file in MB [20] \n");
		printf("        -m nnn = maximum amt xferred in MB [20] \n");
		printf("        -p pre-allocate contig\n");
		printf("        -d direct disk io\n");
		printf("        -a advise = file advisory information [normal] \n");
		printf("                  : normal\tNo further special treatment\n");
		printf("                  : sequential\t:Expect sequential references\n");
		printf("                  : random\t:Expect random references\n");
		printf("                  : willneed\t:Will need the specified range soon\n");
		printf("                  : dontneed\t:Don't need the specified range anymore\n");
		printf("                  : noreuse\t:Expect data won't be reused once accessed\n");
		exit(1);
		break;
		case 't':
		case 'T':
			++argv;
			if(isdigit(*argv[0])){
				numtimes = atoi(argv[0]);
			}
			argc--;
			break;
		case 'b':
		case 'B':
			++argv;
			if(isdigit(**argv)){
				buffer_size = atoi(*argv);
			}
			argc--;
			break;
		case 'f':
		case 'F':
			file_name = *(++argv);
			argc--;
			break;
		case 's':
		case 'S':
			max_file_size = atoi(*(++argv));
			max_file_size *= MB;
			argc--;
			break;
		case 'd':
		case 'D':
			direct = 1;
			break;
		case 'r':
		case 'R':
			random = 1;
			break;
		case 'p':
		case 'P':
			prealloc=1;
			break;
		case 'a':
		case 'A':
			strcpy(advise,*(++argv));
			argc--;
			if (strncmp(advise,"normal",4)==0) {  
				file_advise =POSIX_FADV_NORMAL;
				strcpy(advise,"POSIX_FADV_NORMAL");
			} else if (strncmp(advise,"sequential",1)==0)   {
				file_advise =POSIX_FADV_SEQUENTIAL;
				strcpy(advise,"POSIX_FADV_SEQUENTIAL");
			} else if (strncmp(advise,"random",1)==0)   {
				file_advise =POSIX_FADV_RANDOM;
				strcpy(advise,"POSIX_FADV_RANDOM");
			} else if (strncmp(advise,"willneed",1)==0)   {
				file_advise =POSIX_FADV_WILLNEED;
				strcpy(advise,"POSIX_FADV_WILLNEED");
			} else if (strncmp(advise,"dontneed",3)==0)   {
				file_advise =POSIX_FADV_DONTNEED;
				strcpy(advise,"POSIX_FADV_DONTNEED");
			} else if (strncmp(advise,"noreuse",4)==0)   {
				file_advise =POSIX_FADV_NOREUSE;
				strcpy(advise,"POSIX_FADV_NOREUSE");
				xfs=1;
			} else {
		printf("        -a advise = file advisory information [normal] \n");
		printf("                  : normal\n");
		printf("                  : sequential\n");
		printf("                  : random\n");
		printf("                  : willneed\n");
		printf("                  : dontneed\n");
		printf("                  : noreuse\n");
		exit(1);
			}
			break;
		case 'm':
		case 'M':
			maxtrans = atoi(*(++argv));
			maxtrans*= MB;
			argc--;
			break;
		default:
			printf("  Wrong args - use no args for help\n");
			exit(1);
		}
	}
	printf("RedHawk Disk Performance Exerciser R00-00\t");
	while(unlink(file_name) == 0);
	file_fd = open(file_name, (O_RDWR|O_CREAT|O_SYNC|O_DSYNC|O_RSYNC),0644);
	if(file_fd < 0) 
	{
		fprintf(stderr,"open error %s\n",strerror(errno));
		exit(errno);
	}
	statfs(file_name,&statfsbuff);
	switch(statfsbuff.f_type)
	{
		case EXT2_OLD_SUPER_MAGIC:
			printf("ext2 file system test\n");
		break;
		case EXT2_SUPER_MAGIC:
			printf("ext3 file system test\n");
		break;
		case MSDOS_SUPER_MAGIC:
			printf("dos file system test\n");
		break;
		case XFS_SUPER_MAGIC:
			printf("xfs file system test\n");
			xfs=1;
		break;
		default:
			printf("not support file system\n");
			exit(0);
		break;
	}

	if (1)
	{
		printf("Please Wait now pre allocate file...");fflush(stdout);
		for(tmp_cnt = max_file_size; file_fd <= 0 && tmp_cnt > 0;)
		{
			if( posix_fallocate(file_fd,0,tmp_cnt)==0 ) break;
			tmp_cnt /= 2;
		}
		printf("%d bytes\n",tmp_cnt);fflush(stdout);
	}
	max_file_size = tmp_cnt;
	lseek(file_fd,(long)tmp_cnt-4,0);
	write(file_fd,&tmp_cnt,4);
	lseek(file_fd,0L,0);
	close(file_fd);
	sync();
	maxblocks = min(MAXBLOCKS,max_file_size/BLOCK_SIZE);

	if (random)
	{
		do_disc_io(-2);
		do_disc_io(-1);
	}
	else
	{
		do_disc_io(2);
		do_disc_io(1);
	}
}

do_disc_io(
int 	rdwr)			/* 1 = read; 2 = write; 
				   +ve = sequential; -ve = random */
{
	register int bcnt;
	int wsize,totsmp;
	register int rand;
	int	rbyte;
	int	maxbcnt;
	char	*txt;
	static struct sched_param myparam;
	int	error=0,dir_flag=0;

	if (rdwr < 0)
		rand = 1;
	else
		rand = 0;

	if(dbuf == NULL || last_buffer_size < MAX_BUFFER)
	{
		if(dbuf)
		{
			munlock(dbuf,MAX_BUFFER);
			free(dbuf);
		}
		if((dbuf = (void*)memalign(pathconf(file_name,_PC_REC_XFER_ALIGN),MAX_BUFFER)) == NULL)
		{
			perror("malloc");
			exit(errno);
		}

		memset(dbuf,0xff,MAX_BUFFER);
		last_buffer_size = MAX_BUFFER;
		mlock(dbuf,MAX_BUFFER);
	}
	if (((direct||xfs))/*&&(rdwr>0)*/)
	{
		dir_flag=O_DIRECT;
	}
	if((file_fd=open(file_name,(dir_flag|O_RDWR|O_SYNC|O_DSYNC|O_RSYNC),0644)) < 0){
		perror(file_name);
		exit(errno);
	}
	myparam.sched_priority = sched_get_priority_max(SCHED_FIFO);
	sched_setscheduler(P_MYID,SCHED_FIFO,&myparam);
	posix_fadvise(file_fd,0,max_file_size,file_advise);
	for(buf_size = buffer_size; buf_size <= maxblocks; buf_size *= 2)
	{
		wsize = (buf_size*BLOCK_SIZE);
		total_samples = max_file_size / wsize;
		totsmp = total_samples;
		maxbcnt = numtimes;
#if 0
		if (maxbcnt  > (maxtrans/wsize))
			maxbcnt = maxtrans / wsize;
#endif
		switch (rdwr) {
			case -2:	
					if (xfs||direct)
						txt = "WRITE RANDOM(DIRECT_IO)    :";
					else
						txt = "WRITE RANDOM               :";
					break;
			case -1:	
					if (xfs||direct)
						txt = "READ  RANDOM(DIRECT_IO)    :";
					else
						txt = "READ  RANDOM               :";
					break;
			case 1:		
					if (xfs||direct)
						txt = "READ  SEQUENTIAL(DIRECT_IO):";
					else
						txt = "READ  SEQUENTIAL           :";
					if (maxbcnt > totsmp)
						maxbcnt = totsmp;
					break;
			case 2:		
					if (xfs||direct)
						txt = "WRITE SEQUENTIAL(DIRECT_IO):";
					else
						txt = "WRITE SEQUENTIAL           :";
					if (maxbcnt > totsmp)
						maxbcnt = totsmp;
					break;
			default:	txt = "???????";
					maxbcnt = 1;
		}
		printf("%s buffer size:%6.1fKB ",txt,((float)wsize/1024.));
		fflush(stdout);
		lseek(file_fd,0L,0);
		error=0;
		timestart();
		if ( abs(rdwr) == 1) {		/* if read */
			for(bcnt = 0; bcnt < maxbcnt; bcnt++){
				if (rand) {
					rbyte = (int)(drand48() * (double)(max_file_size - wsize));
					lseek(file_fd, rbyte & 0xfffffe00, SEEK_SET);
				}
				if(read(file_fd,dbuf,wsize) != wsize){
					error=1;
					fprintf(stderr,"read error\n",bcnt);
					break;
				}
				fdatasync(file_fd);
			}
		}
		else 
		{				/* else its write */
			for(bcnt = 0; bcnt < maxbcnt; bcnt++){
				if (rand) {
					rbyte = (int)(drand48() * (double)(max_file_size - wsize));
					lseek(file_fd, rbyte & 0xfffffe00, SEEK_SET);
				}
				if(write(file_fd,dbuf,wsize) != wsize){
					fprintf(stderr,"written error\n",bcnt);
					error=1;
					break;
				}
			}
		}
		timeend();
		bps = (float)(maxbcnt * wsize)/(MEG*elapsed_time);
		acs = maxbcnt;
		acs /= elapsed_time;
		pucpu = (elapsed_u_cpu/elapsed_time)*100.;
		pscpu = (elapsed_s_cpu/elapsed_time)*100.;
		if(error==0)
		{
		printf("%10.2f MBytes/s %10.1f /sec; s/u/t cpu= %4.1f %4.1f %4.1f\n",
		bps,acs,pscpu,pucpu,(pucpu+pscpu));
		}
		fflush(stdout);
	}
	nice(20);
	close(file_fd);
}



struct timespec st,et,res;
struct tms stms,etms;

timestart()
{
	clock_gettime(CLOCK_REALTIME,&st);
	times((struct tms *)&stms);
}

timeend()
{
	times((struct tms *)&etms);
	clock_gettime(CLOCK_REALTIME,&et);
	//clock_getres(CLOCK_REALTIME,&res);
        elapsed_time = (double)(et.tv_sec - st.tv_sec) * 1000.0;
	elapsed_time += (double)(et.tv_nsec - st.tv_nsec)/1000000.0;
        elapsed_time /= 1000.0;
	elapsed_u_cpu = (float)((etms.tms_utime-stms.tms_utime)/60.);
	elapsed_s_cpu = (float)((etms.tms_stime-stms.tms_stime)/60.);

}
