import java.io.*;
    
    public class ExecDemo1 {
        static void listDirContents1(String dir)
        throws IOException {
    
            // start the ls command running
    
            Runtime runtime = Runtime.getRuntime();
            Process proc = runtime.exec(
                "ls" + " " + dir);
    
            // put a BufferedReader on the ls output
    
            InputStream inputstream =
                proc.getInputStream();
            InputStreamReader inputstreamreader =
                new InputStreamReader(inputstream);
            BufferedReader bufferedreader =
                new BufferedReader(inputstreamreader);
    
            // read the ls output
    
            String line;
            while ((line = bufferedreader.readLine()) 
                      != null) {
                System.out.println(line);
            }
        
            // check for ls failure
    
            try {
                if (proc.waitFor() != 0) {
                    System.err.println("exit value = " +
                        proc.exitValue());
                }
            }
            catch (InterruptedException e) {
                System.err.println(e);
            }
        }
    
        static void listDirContents2(String dir) {
    
            // create File object for directory
            // and then list directory contents
    
            String[] list = new File(dir).list();
            int len = (list == null ? 0 : list.length);
            for (int i = 0; i < len; i++) {
                System.out.println(list[i]);
            }
        }
    
        public static void main(String[] args) 
            throws IOException {
                if (args.length != 1) {
                    System.out.println(
                        "missing directory");
                    System.exit(1);
                }
            listDirContents1(args[0]);
            listDirContents2(args[0]);
        }
    }
