#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <errno.h>

extern int errno;

int
main(int argc, char *argv[])
{

    int           oflg;
    int           memfd;
    mode_t        omode;
    const char *shmname = "/shared_memory"; /* /dev/shm/shared_memory が作られる */
    struct  shared_memory 
    {
        int  a, b, counter, initial;
    };
    struct  shared_memory *shmaddr = NULL;


    /* set paramater */
    oflg  = O_CREAT | O_RDWR| O_TRUNC;
    omode = 0644;

    /* open shared memory */
    memfd = shm_open(shmname, oflg, omode );
    if(memfd==-1){
        printf("Error: shm_open() Error!! [%d]\n",errno);
        perror(NULL);
        return (-1);
    }

    printf("shm_open() OK!! memfd[%d]\n",memfd);
    /* set the memory object's size */
    if(ftruncate(memfd,sizeof(struct shared_memory))==-1)
    {
      fprintf(stderr,"ftruncate : %s\n",strerror(errno));
      return EXIT_FAILURE;
    }

    /* map the memory object */
    shmaddr=mmap(0,sizeof(struct  shared_memory),PROT_READ | PROT_WRITE,MAP_SHARED,memfd,0);
    if((void *)shmaddr==MAP_FAILED)
    {
      fprintf(stderr,"mmap faild : %s\n",strerror(errno));
      return EXIT_FAILURE;
    }
    printf("map addr is %#x\n",shmaddr);
    printf("input any keys continue:");fflush(stdout);
    getchar();
    printf("OK\n");
    if (munmap(shmaddr,sizeof(struct  shared_memory))<0)
    {
      fprintf(stderr,"munmap faild : %s\n",strerror(errno));
    }
    if (close(memfd)<0)
    {
      fprintf(stderr,"close faild : %s\n",strerror(errno));
    }
    shm_unlink(shmname);

    return (0);
}

